/*
**  Arabic -> Roman Numerals
*/

var arabicToRoman = {

	levels: [{i:"I",v:"V"},{i:"X",v:"L"},{i:"C",v:"D"},{i:"M",v:null}],
	romanObj:   {I:1, V:5, X:10, L:50, C:100, D:500, M:1000},
	ignoreI:  null,
	ignoreII: null,
	
	convert: function(number) {
		this.ignoreI = this.ignoreII = false;
		for (var result="", nstr=""+number, l=0; l < nstr.length; l++)
			result = this.mapDigit(l, nstr) + result;
		return result;
	},
	
	mapDigit: function(l, nstr) {
		if (this.ignoreI ) { this.ignoreI  = false; return ''; }
		if (this.ignoreII) { this.ignoreII = false; return ''; }
	
		var nlen = nstr.length;
		var digit = parseInt(nstr.charAt(nlen-l-1));
		if (l >= 3) {
			var ms = '', n = digit*Math.pow(10,l-3);
			for (var m=0; m < n; m++) ms += 'M';
			return ms; }
	
		var li = this.levels[l].i;
		var lv = this.levels[l].v;
	
		switch (digit) {
			case 0: return '';
			case 1: return li;
			case 2: return li + li;
			case 3: return li + li + li;
			case 4: return li + lv;
			case 5: return lv;
			case 6: return lv + li;
			case 7: return lv + li + li;
			case 8: return lv + li + li + li;
			case 9:
				switch(nstr.charAt(nlen-l-2)) {
				 	case 9:
						this.ignoreI = true;
						switch(nstr.charAt(nlen-l-3)) {
							case 9: this.ignoreII = true; return li + this.levels[l+3].i;
							case 4: this.ignoreII = true; return li + this.levels[l+2].v;
							default: return li + this.levels[l+2].i; }
					case 4: { this.ignoreI = true; return li + this.levels[l+1].v; }
					default:  return li + this.levels[l+1].i;
				}
			default: return digit;
		}
	}
};
